import * as astService from './infra/ast-service';
import * as checkerService from './infra/checker-service';
import * as engine from './infra/engine';
import * as checkers from './task/checkers';
import * as engineBuilder from './task/engine-builder';
declare const _default: {
    buildDefaultEngine: typeof engineBuilder.buildDefaultEngine;
    buildDefaultEngineWithConfig: typeof engineBuilder.buildDefaultEngineWithConfig;
    CheckerEngine: typeof engine.CheckerEngine;
    checkers: typeof checkers;
    util: {
        check: typeof checkerService.check;
        checkPrimitive: typeof checkerService.checkPrimitive;
        checkByRegex: typeof checkerService.checkByRegex;
        makeCache: typeof checkerService.makeCache;
        makeContext: typeof checkerService.makeContext;
        preserveFeatureSite: typeof checkerService.preserveFeatureSite;
        convertCodeToAst: typeof astService.convertCodeToAst;
    };
};
export = _default;
