"use strict";
// SolEngine: An Extensible Language Feature Analysis Tool for Solidity
// Go to https://solengine.github.io for usage and detail
var astService = require("./infra/ast-service");
var checkerService = require("./infra/checker-service");
var engine = require("./infra/engine");
var checkers = require("./task/checkers");
var engineBuilder = require("./task/engine-builder");
module.exports = {
    buildDefaultEngine: engineBuilder.buildDefaultEngine,
    buildDefaultEngineWithConfig: engineBuilder.buildDefaultEngineWithConfig,
    CheckerEngine: engine.CheckerEngine,
    checkers: checkers,
    util: {
        check: checkerService.check,
        checkPrimitive: checkerService.checkPrimitive,
        checkByRegex: checkerService.checkByRegex,
        makeCache: checkerService.makeCache,
        makeContext: checkerService.makeContext,
        preserveFeatureSite: checkerService.preserveFeatureSite,
        convertCodeToAst: astService.convertCodeToAst
    },
};
