import lineColumn = require('line-column');
import LruCache = require('lru-cache');
import { BaseASTNode } from '@solidity-parser/parser/dist/ast-types';
import { CheckerContext, FeatureSite, Filename } from '../model/feature';
import { CodeInfo } from '../model/code';
import { ExtendedASTNodeTypeString, PrimitiveVisitor, StructuredVisitor } from '../model/ast';
export declare function makeCache(size: number): LruCache<Filename, ReturnType<typeof lineColumn>>;
export declare function makeContext(codeInfo: CodeInfo, cacheSize?: number): CheckerContext;
export declare function checkByRegex(context: CheckerContext, regex: RegExp): FeatureSite[];
export declare function preserveFeatureSite(context: CheckerContext, node: BaseASTNode): FeatureSite;
export declare function checkPrimitive(context: CheckerContext, primitiveVisitor: PrimitiveVisitor): void;
export declare function check(context: CheckerContext, structuredVisitorOrNodeName: StructuredVisitor | ExtendedASTNodeTypeString | ExtendedASTNodeTypeString[]): Promise<FeatureSite[]>;
