import { CheckerConfig, CheckerOutputFormatString, CheckerOutputType, FeatureChecker } from '../model/feature';
import { PlainCodeInfo } from '../model/code';
export declare class CheckerEngine<T extends CheckerOutputFormatString> {
    private config;
    private checkers;
    constructor(config: CheckerConfig<T>);
    static new(): CheckerEngine<'object'>;
    static newWithConfig<R extends CheckerOutputFormatString>(config: CheckerConfig<R>): CheckerEngine<R>;
    addChecker(checker: FeatureChecker): CheckerEngine<T>;
    check(codeInfo: PlainCodeInfo): Promise<CheckerOutputType<T>>;
}
