"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckerEngine = void 0;
var checker_service_1 = require("./checker-service");
var ast_service_1 = require("./ast-service");
var io_1 = require("../util/io");
var CheckerEngine = /** @class */ (function () {
    function CheckerEngine(config) {
        this.config = config;
        this.checkers = [];
    }
    CheckerEngine.new = function () {
        return new CheckerEngine({ outputFormat: 'object' });
    };
    CheckerEngine.newWithConfig = function (config) {
        return new CheckerEngine(config);
    };
    CheckerEngine.prototype.addChecker = function (checker) {
        this.checkers.push(checker);
        return this;
    };
    CheckerEngine.prototype.check = function (codeInfo) {
        return __awaiter(this, void 0, void 0, function () {
            var context, result, _i, _a, checker, featureSites;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        context = checker_service_1.makeContext(__assign(__assign({}, codeInfo), { ast: ast_service_1.convertCodeToAst(codeInfo.code) }));
                        result = new Map();
                        _i = 0, _a = this.checkers;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        checker = _a[_i];
                        return [4 /*yield*/, checker.check(context)];
                    case 2:
                        featureSites = _b.sent();
                        if (featureSites.length > 0) {
                            result.set(checker.name, featureSites);
                        }
                        _b.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        if (this.config.outputFormat === 'map') {
                            return [2 /*return*/, result];
                        }
                        else if (this.config.outputFormat === 'object') {
                            return [2 /*return*/, io_1.convertMapToObject(result)];
                        }
                        else if (this.config.outputFormat === 'json') {
                            return [2 /*return*/, JSON.stringify(io_1.convertMapToObject(result))];
                        }
                        else {
                            throw new Error("Unexpected CheckerEngine.config.outputFormat: " + this.config.outputFormat);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return CheckerEngine;
}());
exports.CheckerEngine = CheckerEngine;
