"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkUnicodeLiteral = exports.checkNatSpecComment = exports.checkSpdxLicenseIdentifier = exports.checkTimeUnit = exports.checkEtherUnit = exports.checkHexadecimalLiteral = exports.checkInlineAssembly = exports.checkManualGasControl = exports.checkPragmaSmtChecker = exports.checkPragmaSolidityVersion = exports.checkImportRenaming = exports.checkConstantAndImmutableStateVariable = exports.checkEvent = exports.checkEnum = exports.checkNestedArrayOrStruct = exports.checkStruct = exports.checkArray = exports.checkLibrary = exports.checkStateVariableVisibility = exports.checkFunctionVisibility = exports.checkInterface = exports.checkAbstractContract = exports.checkFunctionModifierOverriding = exports.checkFunctionOverriding = exports.checkSuperVirtualMethodLookup = exports.checkMultipleInheritance = exports.checkSingleInheritance = exports.checkExceptionTryCatch = exports.checkExceptionRequireAssertRevertThrow = exports.checkCreatingContractViaNew = exports.checkTransfer = exports.checkSend = exports.checkCrossContractInvocationLowLevel = exports.checkCrossContractInvocationHighLevel = exports.checkLoop = exports.checkFunctionOverloading = exports.checkReceiveEtherFunction = exports.checkFallbackFunction = exports.checkReturnVariable = exports.checkFreeFunction = exports.checkNamedCall = exports.checkFunctionModifier = exports.checkConstantFunction = exports.checkViewFunction = exports.checkPureFunction = exports.checkFirstClassFunction = exports.checkRecursion = exports.checkReturningMultipleValue = void 0;
var checker_service_1 = require("../infra/checker-service");
function checkReturningMultipleValue(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { var _a, _b; return ((_b = (_a = functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.returnParameters) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 1; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkReturningMultipleValue = checkReturningMultipleValue;
function checkRecursion(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return ({
                            'FunctionCall': function (functionCall) { return ({
                                'Identifier': function (identifier) { return (identifier === null || identifier === void 0 ? void 0 : identifier.name) === (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.name); }
                            }); }
                        }); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkRecursion = checkRecursion;
function checkFirstClassFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'FunctionTypeName')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFirstClassFunction = checkFirstClassFunction;
function checkPureFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.stateMutability) === 'pure'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkPureFunction = checkPureFunction;
function checkViewFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.stateMutability) === 'view'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkViewFunction = checkViewFunction;
function checkConstantFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.stateMutability) === 'constant'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkConstantFunction = checkConstantFunction;
function checkFunctionModifier(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'ModifierDefinition')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFunctionModifier = checkFunctionModifier;
function checkNamedCall(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) { var _a, _b; return ((_b = (_a = functionCall === null || functionCall === void 0 ? void 0 : functionCall.names) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkNamedCall = checkNamedCall;
function checkFreeFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        var result, insideContractDefinition;
        return __generator(this, function (_a) {
            result = [];
            insideContractDefinition = false;
            return [2 /*return*/, new Promise(function (resolve) {
                    checker_service_1.checkPrimitive(context, {
                        'ContractDefinition': function (node) {
                            insideContractDefinition = true;
                        },
                        'ContractDefinition:exit': function (node) {
                            insideContractDefinition = false;
                        },
                        'FunctionDefinition': function (node) {
                            if (!insideContractDefinition) {
                                result.push(checker_service_1.preserveFeatureSite(context, node));
                            }
                        },
                        'SourceUnit:exit': function (node) {
                            resolve(result);
                        },
                    });
                })];
        });
    });
}
exports.checkFreeFunction = checkFreeFunction;
function checkReturnVariable(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) {
                            if (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.returnParameters) {
                                for (var _i = 0, _a = functionDefinition.returnParameters; _i < _a.length; _i++) {
                                    var item = _a[_i];
                                    if (item.name) {
                                        return true;
                                    }
                                }
                            }
                            return false;
                        }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkReturnVariable = checkReturnVariable;
function checkFallbackFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.isFallback; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFallbackFunction = checkFallbackFunction;
function checkReceiveEtherFunction(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.isReceiveEther; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkReceiveEtherFunction = checkReceiveEtherFunction;
function checkFunctionOverloading(context) {
    return __awaiter(this, void 0, void 0, function () {
        var functionNames;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    functionNames = new Set();
                    return [4 /*yield*/, checker_service_1.check(context, {
                            'ContractDefinition': function (contractDefinition) { return ({
                                'FunctionDefinition': function (functionDefinition) {
                                    if (!contractDefinition || !functionDefinition) {
                                        return false;
                                    }
                                    var fullName = contractDefinition.name + '.' + functionDefinition.name;
                                    if (functionNames.has(fullName)) {
                                        return true;
                                    }
                                    else {
                                        functionNames.add(fullName);
                                        return false;
                                    }
                                }
                            }); }
                        })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFunctionOverloading = checkFunctionOverloading;
function checkLoop(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, ['ForStatement', 'WhileStatement', 'DoWhileStatement'])];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkLoop = checkLoop;
function checkCrossContractInvocationHighLevel(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ContractDefinition': function (contractDefinition) { return ({
                            'FunctionCall': function (functionCall) { return ({
                                'MemberAccess': function (memberAccess) {
                                    return contractDefinition && functionCall && memberAccess
                                        && !['super', 'this', contractDefinition.name].includes(memberAccess.expression.name)
                                        && !['call', 'delegatecall', 'staticcall', 'send', 'transfer', 'gas', 'value'].includes(memberAccess.memberName);
                                }
                            }); }
                        }); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkCrossContractInvocationHighLevel = checkCrossContractInvocationHighLevel;
function checkCrossContractInvocationLowLevel(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) { return ({
                            'MemberAccess': function (memberAccess) { return functionCall && memberAccess
                                && functionCall.expression === memberAccess
                                && ['call', 'delegatecall', 'staticcall'].includes(memberAccess.memberName); }
                        }); },
                        'NameValueExpression': function (nameValueExpression) { return ({
                            'MemberAccess': function (memberAccess) { return nameValueExpression && memberAccess
                                && nameValueExpression.expression === memberAccess
                                && ['call', 'delegatecall', 'staticcall'].includes(memberAccess.memberName); }
                        }); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkCrossContractInvocationLowLevel = checkCrossContractInvocationLowLevel;
function checkSend(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) { return ({
                            'MemberAccess': function (memberAccess) {
                                return functionCall && memberAccess && functionCall.expression === memberAccess && memberAccess.memberName === 'send';
                            }
                        }); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkSend = checkSend;
function checkTransfer(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) { return ({
                            'MemberAccess': function (memberAccess) {
                                return functionCall && memberAccess && functionCall.expression === memberAccess && memberAccess.memberName === 'transfer';
                            }
                        }); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkTransfer = checkTransfer;
function checkCreatingContractViaNew(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'NewExpression': function (newExpression) { return (newExpression === null || newExpression === void 0 ? void 0 : newExpression.typeName.type) === 'UserDefinedTypeName'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkCreatingContractViaNew = checkCreatingContractViaNew;
function checkExceptionRequireAssertRevertThrow(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) { return functionCall
                            && functionCall.expression.type === 'Identifier'
                            && (functionCall.expression.name === 'require'
                                || functionCall.expression.name === 'assert'
                                || functionCall.expression.name === 'revert'); },
                        'ThrowStatement': function () { return true; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkExceptionRequireAssertRevertThrow = checkExceptionRequireAssertRevertThrow;
function checkExceptionTryCatch(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'TryStatement')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkExceptionTryCatch = checkExceptionTryCatch;
function checkSingleInheritance(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ContractDefinition': function (contractDefinition) { var _a; return ((_a = contractDefinition === null || contractDefinition === void 0 ? void 0 : contractDefinition.baseContracts) === null || _a === void 0 ? void 0 : _a.length) === 1; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkSingleInheritance = checkSingleInheritance;
function checkMultipleInheritance(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ContractDefinition': function (contractDefinition) { var _a, _b; return ((_b = (_a = contractDefinition === null || contractDefinition === void 0 ? void 0 : contractDefinition.baseContracts) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 1; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkMultipleInheritance = checkMultipleInheritance;
function checkSuperVirtualMethodLookup(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) { return functionCall
                            && functionCall.expression.type === 'MemberAccess'
                            && functionCall.expression.expression.type === 'Identifier'
                            && functionCall.expression.expression.name === 'super'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkSuperVirtualMethodLookup = checkSuperVirtualMethodLookup;
function checkFunctionOverriding(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.override) !== null; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFunctionOverriding = checkFunctionOverriding;
function checkFunctionModifierOverriding(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ModifierDefinition': function (modifierDefinition) { return (modifierDefinition === null || modifierDefinition === void 0 ? void 0 : modifierDefinition.override) !== null; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFunctionModifierOverriding = checkFunctionModifierOverriding;
function checkAbstractContract(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ContractDefinition': function (contractDefinition) { return (contractDefinition === null || contractDefinition === void 0 ? void 0 : contractDefinition.kind) === 'abstract'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkAbstractContract = checkAbstractContract;
function checkInterface(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ContractDefinition': function (contractDefinition) { return (contractDefinition === null || contractDefinition === void 0 ? void 0 : contractDefinition.kind) === 'interface'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkInterface = checkInterface;
function checkFunctionVisibility(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionDefinition': function (functionDefinition) { return (functionDefinition === null || functionDefinition === void 0 ? void 0 : functionDefinition.visibility) !== 'default'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkFunctionVisibility = checkFunctionVisibility;
function checkStateVariableVisibility(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'StateVariableDeclaration': function (stateVariableDeclaration) {
                            if (stateVariableDeclaration === null || stateVariableDeclaration === void 0 ? void 0 : stateVariableDeclaration.variables) {
                                for (var _i = 0, _a = stateVariableDeclaration.variables; _i < _a.length; _i++) {
                                    var variable = _a[_i];
                                    if (variable.visibility !== 'default') {
                                        return true;
                                    }
                                }
                            }
                            return false;
                        }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkStateVariableVisibility = checkStateVariableVisibility;
function checkLibrary(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ContractDefinition': function (contractDefinition) { return (contractDefinition === null || contractDefinition === void 0 ? void 0 : contractDefinition.kind) === 'library'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkLibrary = checkLibrary;
function checkArray(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'VariableDeclaration': function (variableDeclaration) { var _a; return ((_a = variableDeclaration === null || variableDeclaration === void 0 ? void 0 : variableDeclaration.typeName) === null || _a === void 0 ? void 0 : _a.type) === 'ArrayTypeName'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkArray = checkArray;
function checkStruct(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'StructDefinition')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkStruct = checkStruct;
function checkNestedArrayOrStruct(context) {
    return __awaiter(this, void 0, void 0, function () {
        var nestedArrays, nestedStructs;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ArrayTypeName': function (arrayTypeName) { return arrayTypeName
                            && (arrayTypeName.baseTypeName.type === 'ArrayTypeName'
                                || arrayTypeName.baseTypeName.type === 'UserDefinedTypeName'); }
                    })];
                case 1:
                    nestedArrays = _a.sent();
                    return [4 /*yield*/, checker_service_1.check(context, {
                            'StructDefinition': function (structDefinition) { return ({
                                'VariableDeclaration': function (variableDeclaration) {
                                    return structDefinition && variableDeclaration && variableDeclaration.typeName.type === 'UserDefinedTypeName';
                                }
                            }); }
                        })];
                case 2:
                    nestedStructs = _a.sent();
                    return [2 /*return*/, __spreadArrays(nestedArrays, nestedStructs)];
            }
        });
    });
}
exports.checkNestedArrayOrStruct = checkNestedArrayOrStruct;
function checkEnum(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'EnumDefinition')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkEnum = checkEnum;
function checkEvent(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'EventDefinition')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkEvent = checkEvent;
function checkConstantAndImmutableStateVariable(context) {
    return __awaiter(this, void 0, void 0, function () {
        var fileLevelConstants, constantAndImmutableVariables;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'FileLevelConstant')];
                case 1:
                    fileLevelConstants = _a.sent();
                    return [4 /*yield*/, checker_service_1.check(context, {
                            'VariableDeclaration': function (variableDeclaration) { return variableDeclaration
                                && (variableDeclaration.isDeclaredConst || variableDeclaration.isImmutable); }
                        })];
                case 2:
                    constantAndImmutableVariables = _a.sent();
                    return [2 /*return*/, __spreadArrays(fileLevelConstants, constantAndImmutableVariables)];
            }
        });
    });
}
exports.checkConstantAndImmutableStateVariable = checkConstantAndImmutableStateVariable;
function checkImportRenaming(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'ImportDirective': function (importDirective) { return importDirective
                            && (importDirective.unitAlias !== null || importDirective.symbolAliases != null); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkImportRenaming = checkImportRenaming;
function checkPragmaSolidityVersion(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'PragmaDirective': function (pragmaDirective) { return (pragmaDirective === null || pragmaDirective === void 0 ? void 0 : pragmaDirective.name) === 'solidity'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkPragmaSolidityVersion = checkPragmaSolidityVersion;
function checkPragmaSmtChecker(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'PragmaDirective': function (pragmaDirective) { return (pragmaDirective === null || pragmaDirective === void 0 ? void 0 : pragmaDirective.name) === 'experimental' && (pragmaDirective === null || pragmaDirective === void 0 ? void 0 : pragmaDirective.value) === 'SMTChecker'; }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkPragmaSmtChecker = checkPragmaSmtChecker;
function checkManualGasControl(context) {
    return __awaiter(this, void 0, void 0, function () {
        var newStyle, oldStyle;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'FunctionCall': function (functionCall) {
                            var _a;
                            if ((functionCall === null || functionCall === void 0 ? void 0 : functionCall.expression.type) === 'NameValueExpression') {
                                var nameValueExpression = functionCall.expression;
                                if (nameValueExpression.arguments.type === 'NameValueList') {
                                    var nameValueList = nameValueExpression.arguments;
                                    if ((_a = nameValueList.names) === null || _a === void 0 ? void 0 : _a.includes('gas')) {
                                        return true;
                                    }
                                }
                            }
                            return false;
                        }
                    })];
                case 1:
                    newStyle = _a.sent();
                    return [4 /*yield*/, checker_service_1.check(context, {
                            'FunctionCall': function (functionCall) { return functionCall
                                && functionCall.expression.type === 'MemberAccess' && functionCall.expression.memberName === 'gas'; }
                        })];
                case 2:
                    oldStyle = _a.sent();
                    return [2 /*return*/, __spreadArrays(newStyle, oldStyle)];
            }
        });
    });
}
exports.checkManualGasControl = checkManualGasControl;
function checkInlineAssembly(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'InlineAssemblyStatement')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkInlineAssembly = checkInlineAssembly;
function checkHexadecimalLiteral(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, 'HexLiteral')];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkHexadecimalLiteral = checkHexadecimalLiteral;
function checkEtherUnit(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'NumberLiteral': function (numberLiteral) { var _a; return ['wei', 'szabo', 'finney', 'ether', 'gwei'].includes((_a = numberLiteral === null || numberLiteral === void 0 ? void 0 : numberLiteral.subdenomination) !== null && _a !== void 0 ? _a : ''); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkEtherUnit = checkEtherUnit;
function checkTimeUnit(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, checker_service_1.check(context, {
                        'NumberLiteral': function (numberLiteral) { var _a; return ['seconds', 'minutes', 'hours', 'days', 'weeks', 'years'].includes((_a = numberLiteral === null || numberLiteral === void 0 ? void 0 : numberLiteral.subdenomination) !== null && _a !== void 0 ? _a : ''); }
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.checkTimeUnit = checkTimeUnit;
function checkSpdxLicenseIdentifier(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, checker_service_1.checkByRegex(context, /\/\/\s*SPDX-License-Identifier:/g)];
        });
    });
}
exports.checkSpdxLicenseIdentifier = checkSpdxLicenseIdentifier;
function checkNatSpecComment(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, checker_service_1.checkByRegex(context, /\/\/\/|\/\*\*/g)];
        });
    });
}
exports.checkNatSpecComment = checkNatSpecComment;
function checkUnicodeLiteral(context) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, checker_service_1.checkByRegex(context, /unicode["']/g)];
        });
    });
}
exports.checkUnicodeLiteral = checkUnicodeLiteral;
